#!/usr/bin/python

from pynput import keyboard
from time import sleep
import os
import sys
import socket

ROVER_CONTROL_IP = '192.168.99.1'
ROVER_CONTROL_PORT = 10001
MOVE_DETECTED = False

# send UDP data to server
def UDP_send_data(data,ip,port):
    error_code = 0
    UDP_socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    UDP_socket.sendto(data,(ip,port))
    return error_code

# pynput function, detect key pressed
def on_press(key):
    global control_msg
    global MOVE_DETECTED
    if key == keyboard.Key.up:
        control_msg = '100,0,0,0'
        MOVE_DETECTED = True
    elif key == keyboard.Key.down:
        control_msg = '0,100,0,0'
        MOVE_DETECTED = True
    elif key == keyboard.Key.left:
        control_msg = '0,0,100,0'
        MOVE_DETECTED = True
    elif key == keyboard.Key.right:
        control_msg = '0,0,0,100'
        MOVE_DETECTED = True

# pynput function, detect key released            
def on_release(key):
    global MOVE_DETECTED
    MOVE_DETECTED = False
    
#start keyborad control client
def start_control_client(robot_ip,robot_port): 
    global control_msg
    global MOVE_DETECTED
    print("[MSG]> Start control client")
    print("[MSG]> Remote server: {}:{}".format(robot_ip,robot_port) )   
    print("[MSG]> Ctrl-C to exit")
    try:
        # init keyboard capture, run in background
        listener = keyboard.Listener(on_press=on_press,on_release=on_release)
        listener.start()
        control_msg = ""
        while True:
            # no movement detected, set to stop
            if MOVE_DETECTED != True:
                control_msg = '0,0,0,0'
            # movement detected, send values to server
            if control_msg != "":
                print("{}[KEY]> {}".format('\b\b\b\b',control_msg))
                try:
                    UDP_send_data(control_msg,robot_ip, robot_port)  
                except:
                    print("[MSG]> Network error")
                    sys.exit()
            sleep(0.01)   
    finally:
        pynput.keyboard.Listener.stop

# Main
if __name__ == "__main__":
    try:
        start_control_client(ROVER_CONTROL_IP,ROVER_CONTROL_PORT)
    finally:
        print("\b\b[MSG]> Exit")
        sys.exit()
